#include	"LogListFile.h"
#include	"memman.h"

extern	BOOL	UseServerDir;
extern	char	log_dir[];
extern	HWND	m_hWnd;
extern	TCHAR	error_message[];

//----------------------------------------------------------------------------
LogListFile::LogListFile()
{
	logfp = NULL;
}

LogListFile::~LogListFile()
{
#if 0	// 2006-4-26
	if (logfp != NULL) {
		if (fclose(logfp) == 0 ) {
			logfp = NULL;
		}
	}
#endif
	close();
}

//-------------------------------------
// t@CopenƏ𕪊
bool LogListFile::init(const char *servername, const char *bbsname)
{
	if (!UseServerDir) {
		strcpy(bbs, bbsname);
		sprintf(filename, "%s\\%s\\%s", log_dir, bbs, LOGLIST_FILENAME);
		sprintf(bbsdir  , "%s\\%s\\", log_dir, bbs);
	} else {
		strcpy(bbs, bbsname);
		sprintf(filename, "%s\\%s\\%s\\%s", log_dir, servername, bbs, LOGLIST_FILENAME);
		sprintf(bbsdir  , "%s\\%s\\%s\\", log_dir, servername, bbs);
	}

	return open();
}

bool LogListFile::init(const TCHAR *servername, const TCHAR *bbsname)
{
	wcstombs(bbs, bbsname, sizeof(bbs));
	wcstombs(server, servername, sizeof(server));

	return init(server, bbs);
}

//-------------------------------------
// ۑdatt@CXg̓Ǎ
bool LogListFile::open(const char *servername, const char *bbsname)
{
#if 0
	if (UseServerDir == FALSE) {
		strcpy(bbs, bbsname);
		sprintf(filename, "%s\\%s\\%s", log_dir, bbs, LOGLIST_FILENAME);
		sprintf(bbsdir  , "%s\\%s\\", log_dir, bbs);
	} else {
		strcpy(bbs, bbsname);
		sprintf(filename, "%s\\%s\\%s\\%s", log_dir, servername, bbs, LOGLIST_FILENAME);
		sprintf(bbsdir  , "%s\\%s\\%s\\", log_dir, servername, bbs);
	}
#endif
	// t@C΍
	if ((logfp = fopen(filename, "a+")) == NULL) {
		mbstowcs(error_message, filename, MAX_PATH);
		wcscat(error_message, TEXT("I[vɎs"));
		MessageBox(m_hWnd, error_message, TEXT("filelist_open"), MB_OK);
		return false;
	}

	return true;
}

bool LogListFile::open(const TCHAR *servername, const TCHAR *bbsname)
{
	wcstombs(bbs, bbsname, sizeof(bbs));
	wcstombs(server, servername, sizeof(server));

	return open(server, bbs);
}

bool LogListFile::open()
{
	return open(server, bbs);
}

//-------------------------------------
bool LogListFile::close(void)
{
	if (logfp) {
		fclose(logfp);
		logfp = NULL;
	} else {
//		MessageBox(m_hWnd, TEXT("not opened."), TEXT("LogListFile::close"), MB_OK);
	}
	return true;
}

//-------------------------------------
// Ōɓǂ񂾈ʒuԂ
int LogListFile::finditem(const char *datname)
{
	char kugiri[] = "<>";
	char *p1, *p2;
	int  num_read = -1;

	if (!logfp) {
		MessageBox(m_hWnd, TEXT("not opened."), TEXT("LogListFile::finditem"), MB_OK);
		return num_read;
	}

	// 擪ֈړ
	fseek(logfp, 0, SEEK_SET);
	// read
	while (fgets(buff, BUFFSIZE, logfp) != NULL) {
		// datt@C̒o
		if ((p2 = strstr(buff, kugiri)) != NULL) {
			*p2 = '\0';
			p1 = p2 + 2;	// X^C
		}
		// datt@Cr
		if (strcmp(buff, datname) == 0) {
			// found !

			// ȑO̓ǂ񂾈ʒu
			if ((p2 = strstr(p1, kugiri)) != NULL) {
				*p2 = '\0';
				p1 = p2 + 2;
				num_read = atoi(p1);
			}
		}
	}
	return num_read;
}
int LogListFile::finditem(const TCHAR *datname)
{
	char datfile[MAX_DATNAME];
	wcstombs(datfile, datname, sizeof(datfile));
	return finditem(datfile);
}

//-------------------------------------
// XԂ
int LogListFile::totalitem(const char *datname)
{
	char kugiri[] = "<>";
	char *p1, *p2;
	int  num_read = -1;

	if (!logfp) {
		MessageBox(m_hWnd, TEXT("not opened."), TEXT("LogListFile::totalitem"), MB_OK);
		return num_read;
	}

	// 擪ֈړ
	fseek(logfp, 0, SEEK_SET);
	// read
	while (fgets(buff, BUFFSIZE, logfp) != NULL) {
		// datt@C̒o
		if ((p2 = strstr(buff, kugiri)) != NULL) {
			*p2 = '\0';
			p1 = p2 + 2;	// X^C
		}
		// datt@Cr
		if (strcmp(buff, datname) == 0) { // 
			while ( (p2 = strchr(p1, '(')) != NULL) {
				p1 = p2 + 1;
			}

			// X
			if ((p2 = strchr(p1, ')')) != NULL) {
				*p2 = '\0';
				num_read = atoi(p1);
			}
		}
	}
	return num_read;
}

int LogListFile::totalitem(const TCHAR *datname)
{
	char datfile[MAX_DATNAME];
	wcstombs(datfile, datname, sizeof(datfile));
	return totalitem(datfile);
}

//-------------------------------------
bool LogListFile::delitem(const TCHAR *datname)
{
	if (!logfp) {
		MessageBox(m_hWnd, TEXT("not opened."), TEXT("LogListFile::delitem"), MB_OK);
		return false;
	}

//	// ɓo^Ă邩H
//	if (finditem(datname) == -1)
//		return false;

	char kugiri[] = "<>";
	char **readlines, **readlines_tmp;
	char  *linedata ;
	char datfilename[MAX_DATNAME];

	wcstombs(datfilename, datname, sizeof(datfilename));

	// 擪ֈړ
	fseek(logfp, 0, SEEK_SET);

	// Xgǂݍނ߂̏obt@쐬
	int lines=0;
	char *p2;
	readlines = (char**)LocalAlloc(LPTR, sizeof(char*));
	if (readlines == NULL) {
		MessageBox(m_hWnd, TEXT("Allocs"), TEXT("filelist_changeitem"), MB_OK);
		return false;
	}

	// Xg̓ǂݍ݂ƌ
	while (fgets(buff, BUFFSIZE, logfp) != NULL) {
		readlines_tmp = (char**)LocalReAlloc(readlines, sizeof(char*)*(lines+1), (LMEM_ZEROINIT | LMEM_MOVEABLE));
		 linedata  = (char*)LocalAlloc(LPTR, sizeof(char)*(strlen(buff) + 3));
		if ( (readlines_tmp == NULL)||(linedata  == NULL)) {
			MessageBox(m_hWnd, TEXT("ReAllocs"), TEXT("filelist_changeitem"), MB_OK);
			close();
			return false;
		} else {
			readlines = readlines_tmp;
			readlines[lines] = linedata ;
		}
		strcpy(readlines[lines], buff);

		if ((p2 = strstr(buff, kugiri)) != NULL)
			*p2 = '\0';
		if (strcmp(buff, datfilename) == 0) {
			// AXg̃obt@֓ǂݍ܂Ȃ
			continue;
		}
		lines++;
	}
	close();

/*	// ɏ㏑قǂ̂ȂH
	// 擪ֈړ
	fseek(logfp, 0, SEEK_SET);
*/
	// t@CVK쐬
	if ((logfp = fopen(filename, "w")) == NULL) {
		mbstowcs(error_message, filename, MAX_PATH);
		wcscat(error_message, TEXT("I[vɎs"));
		MessageBox(m_hWnd, error_message, TEXT("filelist_changeitem"), MB_OK);
		return false;
	}

	// ǂݍ񂾃f[^
	for (int i=0; i<lines; i++) {
		fputs(readlines[i], logfp);
		LocalFree(readlines[i]);
	}
	// {͂ŃN[YĂ͂ȂC
	// ǁA(0.85)̃WbNƑvȂ͂
	close();

	return true;
}

//-------------------------------------
bool LogListFile::additem(SureItem *item)
{
	if (!logfp) {
		MessageBox(m_hWnd, TEXT("not opened."), TEXT("LogListFile::additem"), MB_OK);
		return false;
	}

	// ɓo^ĂȂH
	if (finditem(item->datname) > -1)
		return false;

	// ŏɒǉƂ́A\ʒu͂Pɂ
	sprintf(buff,"%s<>%s(%d)<>1\n", item->datname, item->name, item->resnum);

	// t@Cֈړ
	fseek(logfp, 0, SEEK_END);
	fputs(buff, logfp);

	return true;
}

bool LogListFile::additem(const TCHAR *datfilename, const TCHAR *surename, const int number)
{
	SureItem item;

	wcstombs(item.datname, datfilename, MAX_DATNAME);
	WideCharToMultiByte(CP_OEMCP, 0,
				surename, -1, item.name, sizeof(item.name), NULL, NULL);
	item.resnum = number;

	return additem(&item);
}

//-------------------------------------
bool LogListFile::changeitem( SureData *data , int nPos )
{
	char kugiri[] = "<>";
	char **readlines, **readlines_tmp;
	char  *linedata;
	char name[MAX_SURE_NAME];

	char datfilename[MAX_DATNAME];
	wcstombs(datfilename, data->datname, sizeof(data->datname));

	int resposition =data->get_resnum(nPos);

	if (!logfp) {
		MessageBox(m_hWnd, TEXT("not opened."), TEXT("LogListFile::changeitem"), MB_OK);
		return false;
	}

	// 擪ֈړ
	fseek(logfp, 0, SEEK_SET);

	// Xgǂݍނ߂̏obt@쐬
	int lines=0;
	char *p1,*p2;
	readlines = (char**)LocalAlloc(LPTR, sizeof(char*));
	if (readlines == NULL) {
		MessageBox(m_hWnd, TEXT("Allocs"), TEXT("filelist_changeitem"), MB_OK);
		close();
		return false;
	}

	// Xg̓ǂݍ݂ƌ
	while (fgets(buff, BUFFSIZE, logfp) != NULL) {
		readlines_tmp = (char**)LocalReAlloc(readlines, sizeof(char*)*(lines+1), (LMEM_ZEROINIT | LMEM_MOVEABLE));
		 linedata  = (char*)LocalAlloc(LPTR, sizeof(char)*(strlen(buff) + 3));
		if ( (readlines_tmp == NULL)||(linedata  == NULL)) {
			MessageBox(m_hWnd, TEXT("ReAllocs"), TEXT("filelist_changeitem"), MB_OK);
			close();
			return false;
		}
		readlines = readlines_tmp;
		readlines[lines] = linedata ;
		strcpy(readlines[lines], buff);

		if ((p2 = strstr(buff, kugiri)) != NULL)
			*p2 = '\0';
		if (strcmp(buff, datfilename) == 0) {
			// 番
			// dat datfilenameœnĂ̂ŉȂ
			p1 = p2 + 2;
			if ( (p2 = strstr(p1, kugiri)) != NULL)
				*p2 = '\0';
			strcpy(name, p1);

			SplitSureName(name);
			int num = data->reslast;
			// ύXGg쐬
			sprintf(readlines[lines],"%s<>%s(%d)<>%d\n", datfilename, name,num, resposition);
		}
		lines++;
	}
	close();

	// t@CVK쐬
	if ((logfp = fopen(filename, "w")) == NULL) {
		mbstowcs(error_message, filename, MAX_PATH);
		wcscat(error_message, TEXT("I[vɎs"));
		MessageBox(m_hWnd, error_message, TEXT("filelist_changeitem"), MB_OK);
		return false;
	}

	// ǂݍ񂾃f[^
	for (int i=0; i<lines; i++) {
		fputs(readlines[i], logfp);
		LocalFree(readlines[i]);
	}
	close();

	return true;
}

bool LogListFile::changeitem(const char *datfilename, const int resposition)
{
	char kugiri[] = "<>";
	char **readlines, **readlines_tmp;
	char  *linedata;
	char name[MAX_SURE_NAME];

	if (!logfp) {
		MessageBox(m_hWnd, TEXT("not opened."), TEXT("LogListFile::changeitem"), MB_OK);
		return false;
	}

	// 擪ֈړ
	fseek(logfp, 0, SEEK_SET);

	// Xgǂݍނ߂̏obt@쐬
	int lines=0;
	char *p1,*p2;
	readlines = (char**)LocalAlloc(LPTR, sizeof(char*));
	if (readlines == NULL) {
		MessageBox(m_hWnd, TEXT("Allocs"), TEXT("filelist_changeitem"), MB_OK);
		close();
		return false;
	}

	// Xg̓ǂݍ݂ƌ
	while (fgets(buff, BUFFSIZE, logfp) != NULL) {
		readlines_tmp = (char**)LocalReAlloc(readlines, sizeof(char*)*(lines+1), (LMEM_ZEROINIT | LMEM_MOVEABLE));
		 linedata  = (char*)LocalAlloc(LPTR, sizeof(char)*(strlen(buff) + 3));
		if ( (readlines_tmp == NULL)||(linedata  == NULL)) {
			MessageBox(m_hWnd, TEXT("ReAllocs"), TEXT("filelist_changeitem"), MB_OK);
			close();
			return false;
		}
		readlines = readlines_tmp;
		readlines[lines] = linedata ;
		strcpy(readlines[lines], buff);

		if ((p2 = strstr(buff, kugiri)) != NULL)
			*p2 = '\0';
		if (strcmp(buff, datfilename) == 0) {
			// 番
			// dat datfilenameœnĂ̂ŉȂ
			p1 = p2 + 2;
			if ( (p2 = strstr(p1, kugiri)) != NULL)
				*p2 = '\0';
			strcpy(name, p1);
			// ύXGg쐬
			sprintf(readlines[lines],"%s<>%s<>%d\n", datfilename, name, resposition);
		}
		lines++;
	}
	close();

	// t@CVK쐬
	if ((logfp = fopen(filename, "w")) == NULL) {
		mbstowcs(error_message, filename, MAX_PATH);
		wcscat(error_message, TEXT("I[vɎs"));
		MessageBox(m_hWnd, error_message, TEXT("filelist_changeitem"), MB_OK);
		return false;
	}

	// ǂݍ񂾃f[^
	for (int i=0; i<lines; i++) {
		fputs(readlines[i], logfp);
		LocalFree(readlines[i]);
	}
	close();

	return true;
}

bool LogListFile::changeitem(const TCHAR *datfilename, const int resposition)
{
	char datfile[MAX_DATNAME];
	wcstombs(datfile, datfilename, sizeof(datfile));
	return changeitem(datfile, resposition);
}

//-------------------------------------
bool LogListFile::deleteLogfile(const TCHAR *datname)
{
	// filename(aquired.txt)̃fBNg̒o
	TCHAR *file_to_delete;
	file_to_delete = new TCHAR [MAX_PATH];
	mbstowcs(file_to_delete, filename, strlen(filename));

	TCHAR *p1 = file_to_delete;
	TCHAR *p2;
	p2 = wcsrchr(file_to_delete, '\\');
	p2++;
	*p2 = '\0';

	// datnameǉč폜Ώۃt@C쐬
	wcscat(file_to_delete, datname);

	// t@C̍폜
	BOOL status = DeleteFile(file_to_delete);
	DELA( file_to_delete );

	if (status == TRUE)
		return true;
	else
		return false;
}

int	LogListFile::SplitSureName( char *name  )
{
	char	*p1=name;
	char 	*p2;

	// Ō'('̈ʒu܂Ō
	while ( (p2 = strchr(p1, '(')) != NULL) {
		p1 = p2 + 1;
	}

	*(p1-1)='\0';	// X𕪊\

	// X߂
	if ((p2 = strchr(p1, ')')) != NULL) {
		*p2 = '\0';
	}
	return atoi(p1);
}


//-------------------------------------
// subject.txt瑍XXV
bool LogListFile::rebuild()
{
	char kugiri[] = "<>";
	char *p1, *p2;
	FILE *subfp;

	// ۑpobt@m
	const	int	entrymax=1024;		// Ȃ
	LogEntry *entries = new LogEntry[entrymax];	// 20ł̂H

	// acquired.txtdatt@CSǂ݂
	int lines = 0;
	if (logfp != NULL)
		close();
	open(server, bbs);

	fseek(logfp, 0, SEEK_SET);
	while (fgets(buff, BUFFSIZE, logfp) != NULL) {
		if ((buff[0] == '0x0d') || (buff[0] == '0x0a'))
			break;

		// datt@C
		if ((p2 = strstr(buff, kugiri)) != NULL) {
			*p2 = '\0';
			strcpy(entries[lines].datfile, buff);
		}
		// X^Cg
		p1 = p2 + 2;
		if ((p2 = strstr(p1, kugiri)) != NULL) {
			*p2 = '\0';
			strcpy(entries[lines].name, p1);

			// Ōɓǂ񂾈ʒu
			p1 = p2 + 2;
			if ((p2 = strchr(p1, '0x0d')) != NULL) {
				*p2 = '\0';
			}
			strcpy(entries[lines].num, p1);
		}

		lines++;

		if ( lines >= entrymax )	break;	// mە𒴂ł؂

	}
	close();

	// subject.txtopen
	char subjectfilename[MAX_PATH];
	sprintf(subjectfilename, "%s%s", bbsdir, SURELIST_FILENAME);
	if ((subfp = fopen(subjectfilename, "rb")) == NULL) {
		mbstowcs(error_message, subjectfilename, MAX_PATH);
		wcscat(error_message, TEXT("subject.txtI[vɎs"));
		MessageBox(m_hWnd, error_message, TEXT("rebuildLogfile"), MB_OK);
		return false;
	}

	// subject.txtdatt@CɊYGg
	int i = 0;
	while (fgets(buff, BUFFSIZE, subfp) != NULL) {
		if ((p2 = strstr(buff, kugiri)) != NULL) {
			*p2 = '\0';
			for (i=0; i<lines; i++) {
				if (strcmp(buff, entries[i].datfile) == 0) { // 
					// XoăRs[
					p1 = p2 = p2 + 2;
					if ((p2 = strchr(p1, '\n')) != NULL) {
						*p2 = '\0';
					}
					int subjnum = SplitSureName( p1 );					// SUBJECT.txt̃X
					int acqunum = SplitSureName( entries[i].name );		// acquired.txt̃X

					// 傫ōXV
					sprintf( entries[i].name , "%s(%d)" , p1 , max( subjnum , acqunum ) );
					break;
				}
			}
		}
	}
	// subject.txtclose
	fclose(subfp);

	// acquired.txtt@CVK쐬
	if ((logfp = fopen(filename, "w")) == NULL) {
		mbstowcs(error_message, filename, MAX_PATH);
		wcscat(error_message, TEXT("acquired.txtVK쐬s"));
		MessageBox(m_hWnd, error_message, TEXT("rebuildLogfile"), MB_OK);
		return false;
	}

	// ǂݍ񂾃f[^
	for (i=0; i<lines; i++) {
		fprintf(logfp, "%s<>%s<>%s", entries[i].datfile, entries[i].name, entries[i].num);
	}

	// ۑpobt@
	DELA( entries );

	close();
	return true;
}
